package com.logicbig.example;

import java.io.Serializable;
import java.util.Objects;

public class CompositeTaskId implements Serializable {
    private EmployeeId employee;
    private long taskId;

    public CompositeTaskId() {
    }

    public CompositeTaskId(EmployeeId employee, long taskId) {
        this.employee = employee;
        this.taskId = taskId;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        CompositeTaskId that = (CompositeTaskId) o;

        if (taskId != that.taskId) return false;
        return employee != null ? employee.equals(that.employee) : that.employee == null;
    }

    @Override
    public int hashCode() {
        return Objects.hash(employee, taskId);
    }

    @Override
    public String toString() {
        return "CompositeTaskId{" +
                "employee=" + employee +
                ", taskId=" + taskId +
                '}';
    }
}