package com.logicbig.example;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import java.util.Date;

public class ExampleMain2 {

    public static void main(String[] args) throws Exception {
        EntityManagerFactory emf =
                Persistence.createEntityManagerFactory("example-unit");
        try {
            persistEntity(emf);
            runNativeQuery(emf);
            findEntityById(emf);
        } finally {
            emf.close();
        }
    }

    private static void persistEntity(EntityManagerFactory emf) throws Exception {
        System.out.println("-- Persisting entity --");
        EntityManager em = emf.createEntityManager();

        Employee e = new Employee( "Darion"," Schaden", "IT");

        Task task1 = new Task(e, 100L);
        task1.setTaskName("Coding");
        task1.setDate(new Date());

        Task task2 = new Task(e, 200L);
        task2.setTaskName("Refactoring");
        task2.setDate(new Date());

        em.getTransaction().begin();
        em.persist(e);
        em.persist(task1);
        em.persist(task2);
        em.getTransaction().commit();
        em.close();
    }

    private static void runNativeQuery(EntityManagerFactory emf) {
        System.out.println("-- Native query --");
        EntityManager em = emf.createEntityManager();
        ExampleMain.nativeQuery(em, "Select * from EMPLOYEE");
        ExampleMain.nativeQuery(em, "Select * from Task");
    }

    private static void findEntityById(EntityManagerFactory emf) {
        System.out.println("-- Finding entity --");
        EntityManager em = emf.createEntityManager();
        EmployeeId employeeId = new EmployeeId("Darion", " Schaden");
        CompositeTaskId taskId = new CompositeTaskId(employeeId, 100);
        Task task = em.find(Task.class, taskId);
        System.out.println(task);
        em.close();
    }
}